 function [ features ] = CalculateFeature( imageFileList, imageBaseDir, dataBaseDir,frame,TextBlock)

%
% imageFileList: cell of file paths
% imageBaseDir: the base directory for the image files
% dataBaseDir: the base directory for the data files that are generated
%  by the algorithm. If this dir is the same as imageBaseDir the files
%  will be generated in the same location as the image files
% sampleType: the samples belong to negative or positive .while negative ,
%  sampleType is -1 ,if not ,sampleType is +1.

%% parameters for train and classify
if(nargin<6)
    sampleNum = 1;
end
%% Calculate the Feature
% patch_size = 16;
% sampling_step = 2; %sampling_step = 1;
% step = 16;

patchsize=8;
gridspacing=1;
sampling_step = 4;
init_K = 12;
final_K = 10; 
no_dims = 45;
FeatureNum = size(imageFileList,1);
FeatureNum = FeatureNum*TextBlock;
features = cell(FeatureNum,1);
% dataBaseDir1 = 'data\WANG\LLECM';
for f =1:size(imageFileList,1)
    %%%%%%%%%%%%%%% compute LLECM
    imageFName = imageFileList{f};
    imageFName = fullfile(imageBaseDir, imageFName);
    window = sp_load_image(imageFName);
%     window = imread(imageFName);
    fprintf('calculatoring   sample feature %s \n',imageFName);
    tic;       
    [dataArr,grid_x,grid_y]=dense_sift(window,patchsize,gridspacing);
    dataArr = dataArr(1:sampling_step:end,1:sampling_step:end,:);
%     dataArr =  covcalculatornoncombination(window,patch_size, sampling_step, step);%L2ECM
    toc;        
    [g_y g_x bin] = size(dataArr);
    dataArr = reshape(dataArr,g_y*g_x,bin);
    
    [mappedX, mapping] = pca(dataArr, no_dims);
    dataArr = mappedX;
    
    %% Model LLECM (dataArr) by using GMM  
    dataSize = size(dataArr,1);
    BlockSize = floor(dataSize/TextBlock);
    for i=1:TextBlock
    dataArrPart = dataArr((i-1)*BlockSize+1:i*BlockSize,:);
    tic;
    [mtrs,omtr] = GaussianMixture(dataArrPart, init_K, final_K, true);
    toc;
    features{TextBlock*(f-1)+i}= omtr.cluster;  
    end     
    dataArr = [];
end
 
baseName =  'object';
outFName = fullfile(dataBaseDir, sprintf('%s%d_feature.mat', baseName,frame));
sp_make_dir(outFName);
save(outFName, 'features');

end